#import "FileTypePatch.h"


@implementation FileTypePatch : QCPatch

+ (int)executionMode
{
	return 2;
}
+ (BOOL)allowsSubpatches
{
	return NO;
}
+ (int)timeMode
{
	return 1;
}


- (id)initWithIdentifier:(id)fp8
{
	id z=[super initWithIdentifier:fp8];

	currentFile = nil;

	return z;
}


- (id)setup:(QCOpenGLContext *)context
{


	return context;
}
- (void)cleanup:(QCOpenGLContext *)context
{


}


- (void)enable:(QCOpenGLContext *)context
{


}
- (void)disable:(QCOpenGLContext *)context
{


}


- (BOOL)execute:(QCOpenGLContext *)context time:(double)time arguments:(NSDictionary *)arguments
{
	BOOL needToCheck = FALSE;
	
	if([[inputFilePath stringValue] length] > 0)
	{
		if( currentFile == nil )
			needToCheck = TRUE;
		else if( [[inputFilePath stringValue] isEqual:currentFile] == FALSE )
			needToCheck = TRUE;
	}
	
	if(needToCheck)
	{
		if(currentFile != nil)
			[currentFile release];
		
		currentFile = [NSString stringWithString:[inputFilePath stringValue]];
		
		// handle path with composition-relative-addressing
		if( [currentFile characterAtIndex:0] != '/')
		{
			if( [currentFile characterAtIndex:0] != '~')
			{
				NSDictionary *options = (NSDictionary*)[_executionRuntime options];
				currentFile = [NSString stringWithFormat:@"%@/%@",[options objectForKey:@"runtime.resourcesPath"],currentFile];
			}
			else
				currentFile = [currentFile stringByExpandingTildeInPath];
		}
	
		[currentFile retain];
	
		FSRef fileRef;
		Boolean isDirectory;
		
		if (FSPathMakeRef((const UInt8 *)[currentFile fileSystemRepresentation], &fileRef, &isDirectory) == noErr)
        {
			CFDictionaryRef values = NULL;
			CFStringRef attrs[1] = { kLSItemContentType };
			CFArrayRef attrNames = CFArrayCreate(NULL, (const void**)attrs, 1, NULL);
                
			if( LSCopyItemAttributes(&fileRef, kLSRolesViewer, attrNames, &values) == noErr)
			{
					if(values != NULL)
					{
							CFTypeRef uti = CFDictionaryGetValue(values, kLSItemContentType);
							if(uti != NULL)
								[outputUTI setStringValue:(NSString*)uti];
					}
					CFRelease(values);
			}
			CFRelease(attrNames);
        }
	}

	return YES;
}

@end
